﻿/*
 * Created by SharpDevelop.
 * User: Maciek
 * Date: 2015-06-15
 * Time: 19:43
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
 
using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using NUnit.Framework;
using OpenQA.Selenium;
using OpenQA.Selenium.Firefox;
using OpenQA.Selenium.Support.PageObjects;
using OpenQA.Selenium.Support.UI;

namespace PierwszaSolucja
{
	[TestFixture]
	public class PKSZielonaGora
	{
		private IWebDriver driver;
        private StringBuilder verificationErrors;
        private string baseURL;
        WebDriverWait wait;
        ZakupBiletu zb;
        
		[SetUp]
        public void SetupTest()
        {
            driver = new FirefoxDriver();
            baseURL = "http://www.pks.zgora.pl/";
            verificationErrors = new StringBuilder();
            driver.Navigate().GoToUrl(baseURL);
        }
        
		[Test]
        public void WybieranieElementuZListy()
        {
            driver.Navigate().GoToUrl(baseURL);
            PoczekajNaZaladowanieElementu(By.LinkText("Kup bilet miesięczny")).Click();
            PoczekajNaZaladowanieElementu(By.Id("content"));
            new SelectElement(driver.FindElement(By.Id("poczatek"))).SelectByIndex(1);
            new SelectElement(driver.FindElement(By.Id("poczatek"))).SelectByText("Broniszów");
            new SelectElement(driver.FindElement(By.Id("poczatek"))).SelectByValue("115");
        }
        
        [Test]
        public void LosowanieElementuZListy()
        {
            driver.Navigate().GoToUrl(baseURL);
            PoczekajNaZaladowanieElementu(By.LinkText("Kup bilet miesięczny")).Click();
            PoczekajNaZaladowanieElementu(By.Id("content"));
            WylosujElementZComboboxa(By.Id("poczatek"));
            Thread.Sleep(5000);
        }
        
        [Test]
        public void ZakupBiletu()
        {
        	try
        	{
	        	zb = new ZakupBiletu(driver);
	        	PageFactory.InitElements(driver, zb);
	        	zb.KupBilet("6:00", "17:00");
        	}
        	catch(Exception ex)
        	{
        		zb.ZrobZdjecie(ex.Message.Replace(":", "-"));
        	}
        }
		
		[TearDown]
        public void TeardownTest()
        {
            try
            {
                driver.Quit();
            }
            catch (Exception)
            {
                // Ignore errors if unable to close the browser
            }
            Assert.AreEqual("", verificationErrors.ToString());
        }
        
        public IWebElement PoczekajNaZaladowanieElementu(By by, int sekundy = 10)
        {
        	wait = new WebDriverWait(driver, TimeSpan.FromSeconds(sekundy));
        	IWebElement element = wait.Until(x=> driver.FindElement(by));        	           
        	return element;
        }
        
        public IWebElement WylosujElementZComboboxa(By by)
        {
        	Random rand = new Random();
        	IWebElement element = driver.FindElement(by);
        	IList<IWebElement> elementy = element.FindElements(By.TagName("option"));
        	new SelectElement(element).SelectByIndex(rand.Next(0, elementy.Count));
        	
        	return element;
        }
	}
}
